MailCommand = Struct.new(:session, :body) do
  def call
    # MAIL <SP> FROM:<reverse-path> <CLRF>
    if session.domain
      if reverse_path_match = /FROM:<(.+)>/.match(body)
        session.reverse_path = reverse_path_match[1]
        session.reply(250)
      else
        session.reply(501)
      end
    else
      session.reply(451)
    end
  end
end
